/*
 * C
 *
 * Copyright 2013-2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "LLDEVICE_impl.h"
#include <stdio.h>
#include <string.h>
#include "device.h"

#include <sni.h>

uint8_t LLDEVICE_IMPL_getArchitecture(uint8_t* buffer, int32_t length) {
	if (length >= 6) {
		buffer[0]= 'L';
		buffer[1]= 'P';
		buffer[2]= 'C';
		buffer[3]= '5';
		buffer[4]= '4';
		buffer[5]= 0;
		return 1;
	}
	else {
		return 0;
	}
}

uint32_t LLDEVICE_IMPL_getId(uint8_t* buffer, int32_t length) {
    uint32_t command_param[5] = {READ_UID_COMMAND, 0, 0, 0, 0};
    uint32_t status_result[5] = {INVALID_COMMAND, 0, 0, 0, 0};
    IAP iap_entry = (IAP) IAP_LOCATION;

	if(length < UNIQUE_DEVICE_ID_SIZE){
		return 0;
	}

    iap_entry(command_param, status_result);

    if(status_result[0] != CMD_SUCCESS){
      return 0;
    }

    memcpy((void *)buffer, (void *)&status_result[1], UNIQUE_DEVICE_ID_SIZE);

	return UNIQUE_DEVICE_ID_SIZE;
}
